<template>
  <div>
    <ObTabs
        v-model="activeTab"
        :items="tabsItems"
        value-exp="uuid"
    />
    <ObTable
        is-fixed-header
        :items="applications"
        :columns="columns"
        :functional-panel="true"
        :isCssSelectable="true"
        class="advance-table"
        @select="selectedApplication"
        :isSmartPagination="false"
        :remote-opt="{
          method: listAdvances,
          arguments: {
            status: activeTab.uuid
          }
        }"
        :remote-trigger="$route.query"
    >
      <template v-slot:entityNumber="{data}">
        <span
            class="advance-table-link"
            @click="showOrder(data.item)"
        >
          {{data.item.entityNumber}}
        </span>
      </template>
      <template v-slot:totalPrice="{data}">
        <span>{{ transformRubles(data.item.totalPrice) | currency }} ₽</span>
      </template>
      <template v-slot:advanceWithNds="{data}">
        <span>{{ transformRubles(data.item.advanceWithNds) | currency }} ₽</span>
      </template>
      <template v-slot:docServicePrice="{data}">
        <span>{{ transformRubles(data.item.docServicePrice) | currency }} ₽</span>
      </template>
    </ObTable>
  </div>
</template>

<script>
  import ObTabs from 'common-components/src/obComponents/obTabs';
  import ObTable from 'common-components/src/obComponents/obTable';
  import {mapGetters, mapActions, mapMutations} from 'vuex';
  import transformer from '../../account/transformer';
  import moment from 'moment';
  import api from '@/api';

  export default {
    name: "left",
    components: {
      ObTabs,
      ObTable
    },
    mixins: [transformer],
    data() {
      return {
        activeTab: {
          uuid: this.$route.query.status || 'NEW',
        },
        tabsItems: [
          {
            uuid: 'NEW',
            title: 'В работе'
          },
          {
            uuid: 'IN_PROCESS',
            title: 'Неоплаченные'
          },
          {
            uuid: 'FULLY_PAID',
            title: 'Оплаченные'
          },
          {
            uuid: 'CANCELLED',
            title: 'Аннулированные'
          }
        ]
      }
    },
    watch: {
      activeTab({uuid}) {
        this.$router.push({
          path: this.$route.name,
          query: {
            status: uuid
          }
        }).catch(() => {})
      }
    },
    computed: {
      ...mapGetters({
        applications: 'advances/applications'
      }),
      columns() {
        return [
          {
            title: 'Исполнитель',
            key: 'contractorName',
            html: ({contractorName, contractorInn}) => {
              return `
                <div class="advance-table-link">${contractorName}</div>
                <span class="advance-table-contract">${contractorInn}</span>
              `
            }
          },
          {
            title: '№ заказа',
            key: 'entityNumber',
            action: true,
            slotName: 'entityNumber'
          },
          {
            title: 'стоимость перевозки с НДС',
            key: 'totalPrice',
            slotName: 'totalPrice'
          },
          {
            title: 'сумма аванса',
            key: 'advanceWithNds',
            slotName: 'advanceWithNds'
          },
          {
            title: 'Сбор за док-ты, с НДС',
            key: 'docServicePrice',
            slotName: 'docServicePrice'
          },
          {
            title: 'дата запроса аванса',
            key: 'advanceRequestedAt',
            html: ({advanceRequestedAt}) => `${moment(advanceRequestedAt).format('DD.MM.YYYY')}`
          }
        ]
      }
    },
    mounted() {
      if (this.$route.query.hasOwnProperty('status')) {
        this.activeTab = this.tabsItems.find(key => key.uuid === this.$route.query.status);
      }
    },
    methods: {
      ...mapActions({
        selectedApplication: 'advances/selectedApplication'
      }),
      ...mapMutations({
        CLEAR_APPLICATION: 'advances/CLEAR_APPLICATION'
      }),
      async listAdvances({size, page, query, status}) {
        this.CLEAR_APPLICATION();
        const res = await api.advances_payment.getListApplications({ size, page, query, status });
        if (query) {
          query = query.toLowerCase();
          const searchItem = res.content.filter(key =>
            key.contractorName.toLowerCase().indexOf(query) > -1 || key.entityNumber.toLowerCase().indexOf(query) > -1
          );
          return {
            ...res,
            content: [...searchItem]
          };
        }
        return res;
      },
      showOrder({entityUuid}) {
        this.$router.push(`order-item/${entityUuid}?is_suborder=true`)
      },
      showPageOfCanceled() {
        this.activeTab = {
          uuid: 'CANCELLED',
          title: 'Аннулированные'
        }
      }
    }
  }
</script>

<style lang="scss">
  .advance-table {
    &-link {
      font-size: 14px;
      line-height: 18px;
      letter-spacing: 0.2px;
      color: $color-blue-navy-blue;
      cursor: pointer;
    }

    &-contract {
      font-size: 13px;
      line-height: 18px;
      letter-spacing: 0.2px;
      color: $color-text-base;
    }
  }
</style>
